- [HTTP request](https://developers.google.com/pay/card-fop-v1/google-card-fop-api/refundResultNotification#body.HTTP_TEMPLATE)
- [Request body](https://developers.google.com/pay/card-fop-v1/google-card-fop-api/refundResultNotification#body.request_body)
  - [JSON representation](https://developers.google.com/pay/card-fop-v1/google-card-fop-api/refundResultNotification#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://developers.google.com/pay/card-fop-v1/google-card-fop-api/refundResultNotification#body.response_body)
- [RefundResultCode](https://developers.google.com/pay/card-fop-v1/google-card-fop-api/refundResultNotification#RefundResultCode)
- [RefundResultNotificationResponse](https://developers.google.com/pay/card-fop-v1/google-card-fop-api/refundResultNotification#RefundResultNotificationResponse)
  - [JSON representation](https://developers.google.com/pay/card-fop-v1/google-card-fop-api/refundResultNotification#RefundResultNotificationResponse.SCHEMA_REPRESENTATION)
- [RefundResultNotificationResultCode](https://developers.google.com/pay/card-fop-v1/google-card-fop-api/refundResultNotification#RefundResultNotificationResultCode)

Notifies Google of the final result of an [`asynchronousRefund`](https://developers.google.com/pay/card-fop-v1/payment-integrator-card-fop-api/asynchronousRefund#google.standardpayments.flows.card_fop_async_refund.v1.PaymentIntegratorCardAsyncRefundService.AsynchronousRefund) request.

The `refundResult` value is idempotent for this `refundRequestId` and cannot be changed by a subsequent call to this method.

If the endpoint encounters an error while processing the request, the endpoint will return HTTP 4xx or 5xx and the HTTP body will either be of type [`ErrorResponse`](https://developers.google.com/pay/card-fop-v1/payment-integrator-card-fop-api/ErrorResponse) or contain a generic error (e.g. a message similar to "There was an error. Please try again later.").

The generic error is used in situations where an [`ErrorResponse`](https://developers.google.com/pay/card-fop-v1/payment-integrator-card-fop-api/ErrorResponse) with a clear description could be used to help an attacker understand the payment integrator account identifier of other integrators. In these situations, where either the signing key doesn't match, the payment integrator identifier was not found, or the encryption key was unknown, this method will return a generic error. If the request signature could be verified, additional information regarding the error will be returned in an [`ErrorResponse`](https://developers.google.com/pay/card-fop-v1/payment-integrator-card-fop-api/ErrorResponse).

An example request looks like:


    {
      "requestHeader": {
        "protocolVersion": {
          "major": 1,
          "minor": 0,
          "revision": 0
        },
        "requestId": "8a986fe8-5a2c-45a4-a1bb-3bed6e651020",
        "requestTimestamp": "1482452962000"
      },
      "paymentIntegratorAccountId": "SpeedyPaymentsIndia_INR",
      "paymentIntegratorRefundId": "UJ97F3RY8R",
      "refundRequestId": "liUrreQY233839dfFFb24gaQM",
      "refundResult": "SUCCESS",
      "rawResult": {
        "scope": "VISA",
        "rawCode": "00"
      }
    }

An example response looks like:


    {
      "responseHeader": {
        "responseTimestamp": "1482452962840"
      },
      "result": "SUCCESS"
    }

### HTTP request

`POST https://vgw.googleapis.com/secure-serving/gsp/google-card-fop-api/v1/refundResultNotification/https://developers.google.com/pay/card-fop-v1/reference/glossary#payment_integrator_account_id`

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "requestHeader": { object (https://developers.google.com/pay/card-fop-v1/payment-integrator-card-fop-api/RequestHeader) }, "paymentIntegratorAccountId": string, "paymentIntegratorRefundId": string, "refundRequestId": string, "refundResult": enum (`https://developers.google.com/pay/card-fop-v1/google-card-fop-api/refundResultNotification#RefundResultCode`), "rawResult": { object (https://developers.google.com/pay/card-fop-v1/payment-integrator-card-fop-api/CardNetworkResult#RawResult) } } ``` |

| Fields ||
|---|---|
| `requestHeader` | `object (https://developers.google.com/pay/card-fop-v1/payment-integrator-card-fop-api/RequestHeader)` **REQUIRED**: Common header for all requests. |
| `paymentIntegratorAccountId` | `string` **REQUIRED**: This is the payment integrator account identifier that identifies contractual constraints around this transaction. |
| `paymentIntegratorRefundId` | `string` **OPTIONAL**: This identifier is specific to the integrator and is generated by the integrator. The integrator identifies this refund in their system by this identifier. For convenience, this identifier is included with in the remittance details |
| `refundRequestId` | `string` **REQUIRED** : A unique identifier for the refund. This is the `requestId` generated by Google during the `asynchronousRefund` call which this request is associated with. |
| `refundResult` | ``enum (`https://developers.google.com/pay/card-fop-v1/google-card-fop-api/refundResultNotification#RefundResultCode`)`` **REQUIRED**: Result of this refund. |
| `rawResult` | `object (https://developers.google.com/pay/card-fop-v1/payment-integrator-card-fop-api/CardNetworkResult#RawResult)` **OPTIONAL** : Raw result of this refund. Used to help inform Google's risk engine and analytics. In decline code--mapping situations, data is sometimes lost. The integrator can choose to give Google a raw code. For example, a credit card gateway (the integrator) may use this field to communicate to Google the exact decline code that was received from the VISA network. In that case, the `scope` would be "visa" and the `rawCode` would be whatever the VISA network returned. This value is **required** if the `result` is not `SUCCESS`. |

### Response body

This method supports multiple return types. For additional information about what 4XX or 5XX HTTP status code to return with an `ErrorResponse`, consult the `ErrorResponse` object and [HTTP status codes documentation](https://developers.google.com/pay/card-fop-v1/guides/connectivity/protocol-standards#http_status_codes).

| Possible response messages ||
|---|---|
| HTTP 200 Status | ``object (`https://developers.google.com/pay/card-fop-v1/google-card-fop-api/refundResultNotification#RefundResultNotificationResponse`)`` |
| HTTP 4XX / 5XX Status | `object (https://developers.google.com/pay/card-fop-v1/payment-integrator-card-fop-api/ErrorResponse)` |
| End of mutually exclusive fields. ||

## RefundResultCode

Result codes for refunds.

| Enums ||
|---|---|
| `REFUND_RESULT_CODE_UNSPECIFIED` | Do not ever set this default value! |
| `SUCCESS` | Successful refund. |
| `NO_MONEY_LEFT_ON_TRANSACTION` | Refund failed, there is no money left on the transaction. Typically this represents bug between the integrator and Google. Google should not ask to refund an amount greater than the original capture. |
| `REFUND_WINDOW_EXCEEDED` | The refund cannot be processed because the request is outside of the allowed refund period. |
| `NOT_SUPPORTED_BY_NETWORK` | Refund is not supported by network. For example, a partial refund. |
| `ISSUER_DECLINED` | The refund was declined by the issuer. |
| `CARD_LOST_OR_STOLEN` | The card has been lost or stolen. |
| `CARD_CANCELLED` | The refund was declined by the issuer. |
| `CHARGEBACK_IN_PLACE` | The refund was declined because there is already a chargeback in place. |

## RefundResultNotificationResponse

Response object for the Google hosted RefundNotification method.

| JSON representation |
|---|
| ``` { "responseHeader": { object (https://developers.google.com/pay/card-fop-v1/payment-integrator-card-fop-api/ResponseHeader) }, "result": enum (`https://developers.google.com/pay/card-fop-v1/google-card-fop-api/refundResultNotification#RefundResultNotificationResultCode`) } ``` |

| Fields ||
|---|---|
| `responseHeader` | `object (https://developers.google.com/pay/card-fop-v1/payment-integrator-card-fop-api/ResponseHeader)` **REQUIRED**: Common header for all responses. |
| `result` | ``enum (`https://developers.google.com/pay/card-fop-v1/google-card-fop-api/refundResultNotification#RefundResultNotificationResultCode`)`` **REQUIRED**: Result of this call. |

## RefundResultNotificationResultCode

Result codes for the `refundResultNotification` method.

| Enums ||
|---|---|
| `REFUND_RESULT_NOTIFICATION_RESULT_CODE_UNSPECIFIED` | Do not ever set this default value! |
| `SUCCESS` | Refund result notification was successfully processed. |